import { NgModule, ModuleWithProviders } from '@angular/core';

import { ModuleConfig } from '@ucap/api-contact';

import { _MODULE_CONFIG } from './config/token';

import { ContactApiService } from './services/contact-api.service';

const SERVICES = [ContactApiService];

@NgModule({})
export class ContactApiRootModule {}

@NgModule({})
export class ContactApiModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<ContactApiRootModule> {
    return {
      ngModule: ContactApiRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
