import { NgModule, ModuleWithProviders } from '@angular/core';

import { ModuleConfig } from '@ucap/api-message';

import { _MODULE_CONFIG } from './config/token';

import { MessageApiService } from './services/message-api.service';

const SERVICES = [MessageApiService];

@NgModule({})
export class MessageApiRootModule {}

@NgModule({})
export class MessageApiModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<MessageApiRootModule> {
    return {
      ngModule: MessageApiRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
