import { ValidatorFn, AbstractControl } from '@angular/forms';

import { StringUtil as UcapStringUtil } from '@ucap/core';

export class StringUtil extends UcapStringUtil {
  public static checkSpecialCharacter(): ValidatorFn {
    const fn = (control: AbstractControl): { [key: string]: any } | null => {
      // const forbidden = /[\{\}\[\]\/?.;:|\)*~`!^+<>@\#$%&\\\=\(\'\"]/g.test(
      //   control.value
      // );
      const forbidden = new RegExp(
        '[\\{\\}\\[\\]\\/?.;:|\\)*~`!^+<>@\\#$%&\\\\\\=\\(\\\'\\"|\\u00a1-' +
          '\\u00ac|\\u00ae-\\u00ff|\\u0100-\\u017f|\\u0180-\\u024f|\\' +
          'u1e02-\\u1ef3|\\u0259-\\u0292|\\u02b0-\\u02ff|\\u0370-\\u' +
          '03ff|\\u1f00-\\u1fff|\\u0400-\\u04ff|\\u2013-\\u204a|\\u2' +
          '010-\\u206f|\\u2070-\\u209f|\\u20a0-\\u20bf|\\u2100-\\u21' +
          '4f|\\u2150-\\u218f|\\u2190-\\u21ff|\\u2200-\\u22ff|\\u230' +
          '0-\\u23ff|\\u2460-\\u24ff|\\u2500-\\u257f|\\u2580-\\u259f' +
          '|\\u25a0-\\u25ff|\\u2600-\\u26ff|\\u3041-\\u309f|\\u30a0-' +
          '\\u30ff|\\u3100-\\u312f|\\u2e80-\\u2eff|\\u31c0-\\u31ef|\\' +
          'u3000-\\u303f|\\u3200-\\u32ff|\\uff00-\\uffef|\\u3190-\\u' +
          '319f|\\u2f00-\\u2fdf|\\u31f0-\\u31ff|\\ua4d0-\\ua4ff|\\ua' +
          '700-\\ua71f|\\ufe50-\\ufe6f|\\ufe10-\\ufe1f|\\ua000-\\ua4' +
          '8c|\\ua490-\\ua4cf|\\u33c2-\\u33d8]',
        'g'
      ).test(control.value);
      return forbidden ? { groupName: { value: control.value } } : null;
    };

    return fn;
  }

  public static getProfileSubDir(info: string): string {
    let imgUrl: string;
    const tempImgInfo: string = info.toLowerCase();
    const findIdx = tempImgInfo.indexOf('profileimage');

    if (findIdx > -1) {
      const startIdx = info.indexOf('/', findIdx);
      imgUrl = info.substring(startIdx);
    } else {
      imgUrl = info;
    }

    return imgUrl;
  }
}
