import { NgModule, ModuleWithProviders } from '@angular/core';
import { CommonModule } from '@angular/common';

import { ModuleConfig } from '@ucap/i18n';

import { _MODULE_CONFIG } from './config/token';

import { I18nPipe } from './pipes/i18n.pipe';

import { I18nService } from './services/i18n.service';

const COMPONENTS = [];
const DIALOGS = [];
const PIPES = [I18nPipe];
const DIRECTIVES = [];
const SERVICES = [I18nService];

@NgModule({
  declarations: [],
  imports: [],
  exports: []
})
export class I18nRootModule {}

@NgModule({
  imports: [CommonModule],
  exports: [...COMPONENTS, ...DIRECTIVES, ...PIPES],
  declarations: [...COMPONENTS, ...DIRECTIVES, ...PIPES],
  entryComponents: [...DIALOGS]
})
export class I18nModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<I18nRootModule> {
    return {
      ngModule: I18nRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
