import { Injectable, Inject } from '@angular/core';

import {
  ModuleConfig,
  ProtocolService as UCAPProtocolService
} from '@ucap/protocol';
import { LogService } from '@ucap/ng-logger';
import { WebSocketService } from '@ucap/ng-web-socket';

import { _MODULE_CONFIG } from '../config/token';

@Injectable({
  providedIn: 'root'
})
export class ProtocolService extends UCAPProtocolService {
  constructor(
    @Inject(_MODULE_CONFIG) moduleConfig: ModuleConfig,
    webSocketService: WebSocketService,
    logService: LogService
  ) {
    super(moduleConfig, webSocketService, logService);
  }
}
