import { createAction, props } from '@ngrx/store';

import { UserPermission } from '@ucap/domain-authorization';

import { AuthRequest } from '@ucap/protocol-query';
import { RegViewRequest } from '@ucap/protocol-option';
import { Settings } from '@ucap/domain-authentication';

/**
 * retrieve authorization information
 */
export const auth = createAction(
  '[ucap::authentication::authorization] auth',
  props<{ req: AuthRequest }>()
);
/**
 * Success of auth request
 */
export const authSuccess = createAction(
  '[ucap::authentication::authorization] auth Success',
  props<{ userPermission: UserPermission }>()
);
/**
 * Failure of auth request
 */
export const authFailure = createAction(
  '[ucap::authentication::authorization] auth Failure',
  props<{ error: any }>()
);

/**
 * retrieve authorization information
 */
export const regView = createAction(
  '[ucap::authentication::authorization] regView',
  props<{ req: RegViewRequest }>()
);
/**
 * Success of regView request
 */
export const regViewSuccess = createAction(
  '[ucap::authentication::authorization] regView Success',
  props<{ settings: Settings }>()
);
/**
 * Failure of regView request
 */
export const regViewFailure = createAction(
  '[ucap::authentication::authorization] regView Failure',
  props<{ error: any }>()
);
