import { createReducer, on } from '@ngrx/store';

import { initialState } from './state';
import { authSuccess, regViewSuccess } from './actions';

export const reducer = createReducer(
  initialState,
  on(authSuccess, (state, action) => {
    return {
      ...state,
      userPermission: {
        ...state.userPermission,
        ...action.userPermission
      }
    };
  }),
  on(regViewSuccess, (state, action) => {
    return {
      ...state,
      settings: {
        ...state.settings,
        ...action.settings
      }
    };
  })
);
