import { Selector, createSelector } from '@ngrx/store';

import { Settings } from '@ucap/domain-authentication';
import { UserPermission } from '@ucap/domain-authorization';

export interface State {
  userPermission: UserPermission | null;
  settings: Settings | null;
}

export const initialState: State = {
  userPermission: null,
  settings: null
};

export function selectors<S>(selector: Selector<any, State>) {
  return {
    userPermission: createSelector(
      selector,
      (state: State) => state.userPermission
    ),
    settings: createSelector(selector, (state: State) => state.settings)
  };
}
