import { createAction, props } from '@ngrx/store';

import { VersionInfo2Request } from '@ucap/api-public';
import { UrlInfoRequest } from '@ucap/api-external';
import { VersionInfo, UrlInfo } from '@ucap/domain-authentication';

export const versionInfo2 = createAction(
  '[ucap::authentication::configuration] versionInfo2',
  props<{ req: VersionInfo2Request }>()
);

export const versionInfo2Success = createAction(
  '[ucap::authentication::configuration] versionInfo2 Success',
  props<{ versionInfo: VersionInfo }>()
);

export const versionInfo2Failure = createAction(
  '[ucap::authentication::configuration] versionInfo2 Failure',
  props<{ error: any }>()
);

export const urlInfo = createAction(
  '[ucap::authentication::configuration] urlInfo',
  props<{ req: UrlInfoRequest }>()
);

export const urlInfoSuccess = createAction(
  '[ucap::authentication::configuration] urlInfo Success',
  props<{ urlInfo: UrlInfo }>()
);

export const urlInfoFailure = createAction(
  '[ucap::authentication::configuration] urlInfo Failure',
  props<{ error: any }>()
);
