import { createReducer, on } from '@ngrx/store';
import { initialState } from './state';
import { versionInfo2Success, urlInfoSuccess } from './actions';

export const reducer = createReducer(
  initialState,
  on(versionInfo2Success, (state, action) => {
    return {
      ...state,
      versionInfo: {
        ...state.versionInfo,
        ...action.versionInfo
      }
    };
  }),
  on(urlInfoSuccess, (state, action) => {
    return {
      ...state,
      urlInfo: {
        ...state.urlInfo,
        ...action.urlInfo
      }
    };
  })
);
