import { Selector, createSelector } from '@ngrx/store';

import { VersionInfo, UrlInfo } from '@ucap/domain-authentication';

export interface State {
  versionInfo: VersionInfo | null;
  urlInfo: UrlInfo | null;
}

export const initialState: State = {
  versionInfo: null,
  urlInfo: null
};

export function selectors<S>(selector: Selector<any, State>) {
  return {
    versionInfo: createSelector(selector, (state: State) => state.versionInfo),
    urlInfo: createSelector(selector, (state: State) => state.urlInfo)
  };
}
