import { createAction, props } from '@ngrx/store';

import {
  CallHistoryInfoRequest,
  CallHistoryInfoResponse,
  CallHistoryDelRequest,
  CallHistoryDelResponse
} from '@ucap/api-contact';

import { AuthRequest, AuthResponse } from '@ucap/protocol-query';
// import { RegViewRequest, RegViewResponse } from '@ucap/protocol-option';

/**
 * retrieve call history
 */
export const callHistory = createAction(
  '[ucap::call::call] call history',
  props<{ req: CallHistoryInfoRequest }>()
);
/**
 * Success of call history request
 */
export const callHistorySuccess = createAction(
  '[ucap::call::call] call history Success',
  props<{ res: CallHistoryInfoResponse; remainHistory: boolean }>()
);
/**
 * Failure of call history request
 */
export const callHistoryFailure = createAction(
  '[ucap::call::call] call history Failure',
  props<{ error: any }>()
);

/**
 * retrieve delete call history
 */
export const del = createAction(
  '[ucap::call::call] delete call history',
  props<{ req: CallHistoryDelRequest }>()
);
/**
 * Success of delete call history request
 */
export const delSuccess = createAction(
  '[ucap::call::call] delete call history Success',
  props<{ callLogSeq: number }>()
);
/**
 * Failure of delete call history request
 */
export const delFailure = createAction(
  '[ucap::call::call] delete call history Failure',
  props<{ error: any }>()
);
