import { createReducer, on } from '@ngrx/store';

import { initialState, adapterCallHistory } from './state';
import { callHistorySuccess, delSuccess } from './actions';

export const reducer = createReducer(
  initialState,

  on(callHistorySuccess, (state, action) => {
    return {
      ...state,
      searchDate: action.res.searchDate,
      searchDirection: action.res.searchDirection,
      historyList: adapterCallHistory.upsertMany(action.res.historyList, {
        ...state.historyList
      }),
      remainHistory: action.remainHistory
    };
  }),

  on(delSuccess, (state, action) => {
    return {
      ...state,
      historyList: adapterCallHistory.removeOne(action.callLogSeq, {
        ...state.historyList
      })
    };
  })
);
