import { createFeatureSelector, createSelector } from '@ngrx/store';

import * as CommonState from './common/state';
import * as CallState from './call/state';

export const KEY_FEATURE = 'call';

export interface State {
  common: CommonState.State;
  call: CallState.State;
}

export const Selector = createFeatureSelector<State>(KEY_FEATURE);

export const CommonSelector = CommonState.selectors(
  createSelector(Selector, (state: State) => state.common)
);

export const CallSelector = CallState.selectors(
  createSelector(Selector, (state: State) => state.call)
);
