import { createReducer, on } from '@ngrx/store';

import { GroupInfoDetail } from '@ucap/domain-group';

import { initialState, adapterGroup } from './state';
import { groupsSuccess, createSuccess, delSuccess } from './actions';

export const reducer = createReducer(
  initialState,

  on(groupsSuccess, (state, action) => {
    return {
      ...state,
      groups: adapterGroup.upsertMany(action.groupList, {
        ...state.groups,
        syncDate: action.syncDate
      })
    };
  }),

  /** 새 그룹 추가. */
  on(createSuccess, (state, action) => {
    const res = action.res;
    const groupInfo: GroupInfoDetail = {
      seq: res.groupSeq,
      name: res.groupName,
      isActive: true,
      userSeqs: []
    };
    return {
      ...state,
      groups: adapterGroup.addOne(groupInfo, {
        ...state.groups
      })
    };
  }),

  /** 그룹 삭제 */
  on(delSuccess, (state, action) => {
    const res = action.res;
    return {
      ...state,
      groups: adapterGroup.removeOne(res.groupSeq, {
        ...state.groups
      })
    };
  })
);
