import { Selector, createSelector } from '@ngrx/store';
import { DeptInfo, UserInfoSS } from '@ucap/domain-organization';

export interface State {
  departmentInfoList: DeptInfo[] | null;

  myDepartmentUserInfoList: UserInfoSS[] | null;
}

export const initialState: State = {
  departmentInfoList: null,
  myDepartmentUserInfoList: null
};

export function selectors<S>(selector: Selector<any, State>) {
  return {
    departmentInfoList: createSelector(
      selector,
      (state: State) => state.departmentInfoList
    ),
    myDepartmentUserInfoList: createSelector(
      selector,
      (state: State) => state.myDepartmentUserInfoList
    )
  };
}
