import { createAction, props } from '@ngrx/store';

import { StatusBulkInfo } from '@ucap/domain-status';

import {
  BulkInfoRequest,
  StatusNotification,
  StatusRequest,
  StatusResponse,
  MessageUpdateRequest,
  MessageUpdateResponse
} from '@ucap/protocol-status';

export const bulkInfo = createAction(
  '[ucap::organization::presence] bulkInfo',
  props<BulkInfoRequest>()
);

export const bulkInfoSuccess = createAction(
  '[ucap::organization::presence] bulkInfo Success',
  props<{ statusBulkInfoList: StatusBulkInfo[] }>()
);

export const bulkInfoFailure = createAction(
  '[ucap::organization::presence] bulkInfo Failure',
  props<{ error: any }>()
);

export const statusNotification = createAction(
  '[ucap::organization::presence]  statusNotification',
  props<{ noti: StatusNotification }>()
);

export const status = createAction(
  '[ucap::organization::presence] status',
  props<{ req: StatusRequest }>()
);
export const statusSuccess = createAction(
  '[ucap::organization::presence] statusSuccess',
  props<{
    res: StatusResponse;
  }>()
);
export const statusFailure = createAction(
  '[ucap::organization::presence] statusFailure',
  props<{ error: any }>()
);

export const changeMyIdleCheckTime = createAction(
  '[ucap::organization::presence] changeMyIdleCheckTime',
  props<{ checkTime: number }>()
);

export const messageUpdate = createAction(
  '[ucap::organization::presence] messageUpdate',
  props<{ req: MessageUpdateRequest }>()
);
export const messageUpdateSuccess = createAction(
  '[ucap::organization::presence] messageUpdate Success',
  props<{ res: MessageUpdateResponse }>()
);
export const messageUpdateFailure = createAction(
  '[ucap::organization::presence] messageUpdate Failure',
  props<{ error: any }>()
);
