import { createAction, props } from '@ngrx/store';

import { User } from '@ucap/domain-organization';

import { UserResponse, UserRequest } from '@ucap/protocol-info';

/**
 * info user request
 */
export const init = createAction(
  '[ucap::organization::user] init',
  props<{ user: User }>()
);

/**
 * modifyInfo user request
 */
export const modifyInfo = createAction(
  '[ucap::organization::user] modifyInfo',
  props<{ req: UserRequest }>()
);

/**
 * Success of modifyInfo request
 */
export const modifyInfoSuccess = createAction(
  '[ucap::organization::user] modifyInfo Success',
  props<{
    res: UserResponse;
  }>()
);

/**
 * Failure of modifyInfo request
 */
export const modifyInfoFailure = createAction(
  '[ucap::organization::user] modifyInfo Failure',
  props<{ error: any }>()
);
