import { Selector, createSelector } from '@ngrx/store';
import { EntityState } from '@ngrx/entity';

import { StatusBulkInfo } from '@ucap/domain-status';
import { User } from '@ucap/domain-organization';

export interface StatusBulkInfoState extends EntityState<StatusBulkInfo> {}

export interface State {
  user: User | undefined;
}

export const initialState: State = {
  user: undefined
};

export function selectors<S>(selector: Selector<any, State>) {
  return {
    user: createSelector(selector, (state: State) => state.user)
  };
}
