import { Subject } from 'rxjs';

import {
  Component,
  OnInit,
  OnDestroy,
  ChangeDetectionStrategy,
  ChangeDetectorRef,
  Input
} from '@angular/core';

import { CallHistory, CallResultType } from '@ucap/domain-call';

@Component({
  selector: 'ucap-call-history-list-item',
  templateUrl: './history-list-item.component.html',
  styleUrls: ['./history-list-item.component.scss'],
  changeDetection: ChangeDetectionStrategy.OnPush
})
export class HistoryListItemComponent implements OnInit, OnDestroy {
  @Input()
  historyInfo: CallHistory;

  CallResultType = CallResultType;

  private ngOnDestroySubject: Subject<void>;
  constructor(private changeDetectorRef: ChangeDetectorRef) {}

  ngOnInit(): void {
    this.ngOnDestroySubject = new Subject();
  }

  ngOnDestroy(): void {
    if (!!this.ngOnDestroySubject) {
      this.ngOnDestroySubject.next();
      this.ngOnDestroySubject.complete();
    }
  }

  getName(): string {
    if (!!this.historyInfo.sendYn && this.historyInfo.sendYn === true) {
      return this.historyInfo.calledName;
    } else {
      return this.historyInfo.callingName;
    }
  }

  getPhoneNumber(): string {
    if (!!this.historyInfo.sendYn) {
      return this.historyInfo.calledMa;
    } else {
      return this.historyInfo.callingMa;
    }
  }
}
