import {
  Component,
  OnInit,
  ChangeDetectionStrategy,
  Input,
  OnDestroy,
  EventEmitter,
  Output,
  ChangeDetectorRef
} from '@angular/core';
import { CallHistory, CallResultType } from '@ucap/domain-call';

@Component({
  selector: 'ucap-call-timeline-item',
  templateUrl: './timeline-item.component.html',
  styleUrls: ['./timeline-item.component.scss'],
  changeDetection: ChangeDetectionStrategy.OnPush
})
export class TimelineItemComponent implements OnInit, OnDestroy {
  @Input()
  historyInfo: CallHistory;

  @Input()
  dateChanged: boolean;

  CallResultType = CallResultType;

  constructor(private changeDetectorRef: ChangeDetectorRef) {}

  ngOnInit(): void {}

  ngOnDestroy(): void {}

  getPhoneNumber(): string {
    if (!!this.historyInfo.sendYn) {
      return this.historyInfo.calledMa;
    } else {
      return this.historyInfo.callingMa;
    }
  }

  secondToTime(sec: number): string {
    const duration = sec * 1000;
    const seconds = Math.floor((duration / 1000) % 60);
    const minutes = Math.floor((duration / (1000 * 60)) % 60);
    const hours = Math.floor((duration / (1000 * 60 * 60)) % 24);

    const strHours = String(hours < 10 ? '0' + hours : hours);
    const strMinutes = String(minutes < 10 ? '0' + minutes : minutes);
    const strSeconds = String(seconds < 10 ? '0' + seconds : seconds);

    return strHours + ':' + strMinutes + ':' + strSeconds;
  }
}
