import {
  Component,
  OnInit,
  Input,
  Output,
  EventEmitter,
  ChangeDetectionStrategy
} from '@angular/core';

import { FileEventJson } from '@ucap/domain-chat';

@Component({
  selector: 'ucap-chat-message-box-image',
  templateUrl: './image.component.html',
  styleUrls: ['./image.component.scss'],
  changeDetection: ChangeDetectionStrategy.OnPush
})
export class ImageComponent implements OnInit {
  @Input()
  fileInfo: FileEventJson;

  @Input()
  expired = false;

  @Input()
  fileRetentionPeriod?: number;

  @Output()
  openViewer = new EventEmitter();

  constructor() {}

  ngOnInit() {}

  onClickOpenViewer() {
    if (!this.expired) {
      this.openViewer.emit();
    }
  }
}
