import {
  Component,
  OnInit,
  Input,
  ElementRef,
  AfterViewInit,
  EventEmitter,
  Output,
  ChangeDetectionStrategy
} from '@angular/core';

import { Info, StickerEventJson } from '@ucap/domain-chat';

@Component({
  selector: 'ucap-chat-message-box-sticker',
  templateUrl: './sticker.component.html',
  styleUrls: ['./sticker.component.scss'],
  changeDetection: ChangeDetectionStrategy.OnPush
})
export class StickerComponent implements OnInit, AfterViewInit {
  @Input()
  message: Info<StickerEventJson>;

  @Output()
  openLink = new EventEmitter<string>();

  contents: string;
  constructor(private elementRef: ElementRef) {}

  ngOnInit() {
    if (!!this.message.sentMessageJson?.chat) {
      this.contents = this.message.sentMessageJson.chat;
    }
  }

  ngAfterViewInit(): void {
    if (
      !!this.elementRef.nativeElement &&
      !!this.elementRef.nativeElement.querySelector('a')
    ) {
      const elements = this.elementRef.nativeElement.querySelectorAll('a');
      elements.forEach((element) => {
        element.addEventListener('click', this.onClickEvent.bind(this));
      });
    }
  }

  onClickEvent(event: MouseEvent) {
    this.openLink.emit((event.target as HTMLAnchorElement).text);
  }
}
