import {
  Component,
  OnInit,
  Input,
  Output,
  EventEmitter,
  ChangeDetectionStrategy
} from '@angular/core';
import {
  VideoConferenceEventJson,
  VideoConferenceContentsType,
  Info
} from '@ucap/domain-chat';

@Component({
  selector: 'ucap-chat-message-box-video-conference',
  templateUrl: './video-conference.component.html',
  styleUrls: ['./video-conference.component.scss'],
  changeDetection: ChangeDetectionStrategy.OnPush
})
export class VideoConferenceComponent implements OnInit {
  @Input()
  message: Info<VideoConferenceEventJson>;

  @Input()
  canVideoConference: boolean;

  @Output()
  conferenceDetail = new EventEmitter<VideoConferenceEventJson>();

  @Output()
  conferenceJoin = new EventEmitter<VideoConferenceEventJson>();

  VideoConferenceContentsType = VideoConferenceContentsType;

  constructor() {}

  ngOnInit() {}

  onClickDetailView() {
    this.conferenceDetail.emit(this.message.sentMessageJson);
  }

  onClickEnjoyConference() {
    this.conferenceJoin.emit(this.message.sentMessageJson);
  }
}
