import { moduleMetadata } from '@storybook/angular';
import { action } from '@storybook/addon-actions';
import { linkTo } from '@storybook/addon-links';

import { BrowserModule } from '@angular/platform-browser';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

import { CallMode } from '@ucap/domain-common';
import { RoleCode, UserInfoF, EmployeeType } from '@ucap/domain-organization';

import { OrganizationUiModule } from '../organization-ui.module';

import { ProfileListItem02Component } from './profile-list-item-02.component';

const userInfo: UserInfoF = {
  seq: 1234,
  name: '사용자1',
  profileImageFile: '사진파일',
  grade: '직급',
  intro: '업무소개',
  companyCode: '기관코드',
  hpNumber: '핸드폰번호',
  lineNumber: '내선번호',
  email: '이메일',
  isMobile: true,
  isBuddy: true,
  isFavorit: true,
  /**  */
  deptName: '부서명',
  /**  */
  order: '조회순서',

  isActive: true,
  roleCd: RoleCode.Self,
  employeeNum: 'A34567',
  madn: 'MADN',
  hardSadn: 'HARDPHONE_SADN',
  fmcSadn: 'FMC_SADN',
  nickName: 'nickName',
  nameEn: '사용자명(영어)',
  nameCn: '사용자명(중국어)',
  gradeEn: '직급(영어)',
  gradeCn: '직급(중국어)',
  deptNameEn: '부서명(영어)',
  deptNameCn: '부서명(중국어)',
  isPrivacyAgree: true,
  isValidLogin: true,
  employeeType: EmployeeType.Regular
};

export default {
  title: 'ui-organization::ProfileListItem02Component',
  component: ProfileListItem02Component,
  decorators: [
    moduleMetadata({
      imports: [BrowserModule, BrowserAnimationsModule, OrganizationUiModule],
      providers: []
    })
  ]
};

export const Default = () => ({
  component: ProfileListItem02Component,
  props: {
    userInfo
  }
});
