import { moduleMetadata } from '@storybook/angular';
import { action } from '@storybook/addon-actions';
import { linkTo } from '@storybook/addon-links';

import { BrowserModule } from '@angular/platform-browser';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

import { OrganizationUiModule } from '../organization-ui.module';

import { SearchForTenantComponent } from './search-for-tenant.component';

export default {
  title: 'ui-organization::SearchForTenantComponent',
  component: SearchForTenantComponent,
  decorators: [
    moduleMetadata({
      imports: [BrowserModule, BrowserAnimationsModule, OrganizationUiModule],
      providers: []
    })
  ]
};

export const Default = () => ({
  component: SearchForTenantComponent,
  props: {
    companyList: [
      {
        companyCode: 'CD1',
        companyName: '회사1',
        companyDomain: '회사1',
        companyConfAuthYn: 'Y',
        ucapUseYn: 'Y',
        companyTimerChatAuthYn: 'Y'
      },
      {
        companyCode: 'CD2',
        companyName: '회사2',
        companyDomain: '회사2',
        companyConfAuthYn: 'Y',
        ucapUseYn: 'Y',
        companyTimerChatAuthYn: 'Y'
      },
      {
        companyCode: 'CD3',
        companyName: '회사3',
        companyDomain: '회사3',
        companyConfAuthYn: 'Y',
        ucapUseYn: 'Y',
        companyTimerChatAuthYn: 'Y'
      }
    ]
  }
});
