import { NgModule, ModuleWithProviders } from '@angular/core';
import { CommonModule } from '@angular/common';

import { FlexLayoutModule } from '@angular/flex-layout';

import { MatRippleModule } from '@angular/material/core';

import { I18nModule } from '@ucap/ng-i18n';

import { ModuleConfig } from './config/module-config';
import { _MODULE_CONFIG } from './config/token';

import { BreadcrumbComponent } from './components/breadcrumb.component';
import { BreadcrumbNodeDirective } from './components/breadcrumb.component';

const COMPONENTS = [BreadcrumbComponent];
const DIRECTIVES = [BreadcrumbNodeDirective];
const PIPES = [];
const DIALOGS = [];
const SERVICES = [];

@NgModule({
  declarations: [],
  imports: [],
  exports: []
})
export class UiBreadcrumbRootModule {}

@NgModule({
  imports: [CommonModule, FlexLayoutModule, MatRippleModule, I18nModule],
  exports: [...COMPONENTS, ...DIRECTIVES, ...PIPES],
  declarations: [...COMPONENTS, ...DIALOGS, ...DIRECTIVES, ...PIPES],
  entryComponents: [...DIALOGS]
})
export class UiBreadcrumbModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<UiBreadcrumbRootModule> {
    return {
      ngModule: UiBreadcrumbRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
