import { NgModule, ModuleWithProviders } from '@angular/core';
import { CommonModule } from '@angular/common';

import { FlexLayoutModule } from '@angular/flex-layout';

import { MatButtonModule } from '@angular/material/button';
import { MatButtonToggleModule } from '@angular/material/button-toggle';
import { MatIconModule } from '@angular/material/icon';
import { MatMenuModule } from '@angular/material/menu';
import { MatTooltipModule } from '@angular/material/tooltip';

import { I18nModule } from '@ucap/ng-i18n';

import { ModuleConfig } from './config/module-config';
import { _MODULE_CONFIG } from './config/token';

import { FloatActionButtonComponent } from './components/float-action-button.component';
import { SplitButtonComponent } from './components/split-button.component';

const COMPONENTS = [FloatActionButtonComponent, SplitButtonComponent];
const DIRECTIVES = [];
const PIPES = [];
const DIALOGS = [];
const SERVICES = [];

@NgModule({
  declarations: [],
  imports: [],
  exports: []
})
export class UiButtonRootModule {}

@NgModule({
  imports: [
    CommonModule,
    FlexLayoutModule,

    MatButtonModule,
    MatButtonToggleModule,
    MatIconModule,
    MatMenuModule,
    MatTooltipModule,

    I18nModule
  ],
  exports: [...COMPONENTS, ...DIRECTIVES, ...PIPES],
  declarations: [...COMPONENTS, ...DIALOGS, ...DIRECTIVES, ...PIPES],
  entryComponents: [...DIALOGS]
})
export class UiButtonModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<UiButtonRootModule> {
    return {
      ngModule: UiButtonRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
