import { Directive, Input, TemplateRef, ViewContainerRef } from '@angular/core';

@Directive({
  selector: '[ucapVar]'
})
export class VarDirective<T = unknown> {
  private context?: Context<T>;

  // https://angular.io/guide/structural-directives#typing-the-directives-context
  static ngTemplateContextGuard<T>(
    dir: VarDirective<T>,
    ctx: any
  ): ctx is Context<T> {
    return true;
  }

  constructor(
    private vcRef: ViewContainerRef,
    private templateRef: TemplateRef<Context<T>>
  ) {}

  @Input()
  set ucapVar(value: T) {
    if (this.context) {
      this.context.ucapVar = value;
    } else {
      this.context = { ucapVar: value };
      this.vcRef.createEmbeddedView(this.templateRef, this.context);
    }
  }
}

interface Context<T> {
  ucapVar: T;
}
