import { NgModule, ModuleWithProviders } from '@angular/core';
import { CommonModule } from '@angular/common';

import { FlexLayoutModule } from '@angular/flex-layout';

import { MatProgressBarModule } from '@angular/material/progress-bar';

import { I18nModule } from '@ucap/ng-i18n';

import { ModuleConfig } from './config/module-config';
import { _MODULE_CONFIG } from './config/token';

import { FileUploadQueueComponent } from './components/file-upload-queue.component';
import { FileUploadForDirective } from './directives/file-upload-for.directive';

const COMPONENTS = [FileUploadQueueComponent];
const DIRECTIVES = [FileUploadForDirective];
const PIPES = [];
const DIALOGS = [];
const SERVICES = [];

@NgModule({
  declarations: [],
  imports: [],
  exports: []
})
export class UiFileUploadRootModule {}

@NgModule({
  imports: [CommonModule, FlexLayoutModule, MatProgressBarModule, I18nModule],
  exports: [...COMPONENTS, ...DIRECTIVES, ...PIPES],
  declarations: [...COMPONENTS, ...DIALOGS, ...DIRECTIVES, ...PIPES],
  entryComponents: [...DIALOGS]
})
export class UiFileUploadModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<UiFileUploadRootModule> {
    return {
      ngModule: UiFileUploadRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
