import { moduleMetadata } from '@storybook/angular';
import { action } from '@storybook/addon-actions';
import { linkTo } from '@storybook/addon-links';

import { BrowserModule } from '@angular/platform-browser';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

import { WindowState } from '@ucap/native';

import { UiModule } from '../ui.module';

import { TitleBarComponent } from './title-bar.component';

export default {
  title: 'ui::TitleBarComponent',
  component: TitleBarComponent,
  decorators: [
    moduleMetadata({
      imports: [BrowserModule, BrowserAnimationsModule, UiModule],
      providers: []
    })
  ]
};

export const Default = () => ({
  component: TitleBarComponent,
  props: {}
});

export const Browser = () => ({
  component: TitleBarComponent,
  props: {
    platform: 'browser',
    windowState: WindowState.Normal
  }
});

export const Darwin = () => ({
  component: TitleBarComponent,
  props: {
    platform: 'darwin',
    windowState: WindowState.Normal
  }
});

export const Linux = () => ({
  component: TitleBarComponent,
  props: {
    platform: 'linux',
    windowState: WindowState.Normal
  }
});

export const Win32 = () => ({
  component: TitleBarComponent,
  props: {
    platform: 'win32',
    windowState: WindowState.Normal
  }
});
