import { NgModule, ModuleWithProviders } from '@angular/core';
import { CommonModule } from '@angular/common';

import { FlexLayoutModule } from '@angular/flex-layout';

import { I18nModule } from '@ucap/ng-i18n';

import { ModuleConfig } from './config/module-config';
import { _MODULE_CONFIG } from './config/token';

import { TitleBarComponent } from './components/title-bar.component';

const COMPONENTS = [TitleBarComponent];
const DIRECTIVES = [];
const PIPES = [];
const DIALOGS = [];
const SERVICES = [];

@NgModule({
  declarations: [],
  imports: [],
  exports: []
})
export class UiNativeRootModule {}

@NgModule({
  imports: [CommonModule, FlexLayoutModule, I18nModule],
  exports: [...COMPONENTS, ...DIRECTIVES, ...PIPES],
  declarations: [...COMPONENTS, ...DIALOGS, ...DIRECTIVES, ...PIPES],
  entryComponents: [...DIALOGS]
})
export class UiNativeModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<UiNativeRootModule> {
    return {
      ngModule: UiNativeRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
