import { NgModule, ModuleWithProviders } from '@angular/core';
import { CommonModule } from '@angular/common';

import { FlexLayoutModule } from '@angular/flex-layout';

import { MatRippleModule } from '@angular/material/core';

import { I18nModule } from '@ucap/ng-i18n';

import { ModuleConfig } from './config/module-config';
import { _MODULE_CONFIG } from './config/token';

import { PhoneNumberPipe } from './pipes/phone-number.pipe';

const COMPONENTS = [];
const DIRECTIVES = [];
const PIPES = [PhoneNumberPipe];
const DIALOGS = [];
const SERVICES = [];

@NgModule({
  declarations: [],
  imports: [],
  exports: []
})
export class UiPhoneRootModule {}

@NgModule({
  imports: [CommonModule, FlexLayoutModule, MatRippleModule, I18nModule],
  exports: [...COMPONENTS, ...DIRECTIVES, ...PIPES],
  declarations: [...COMPONENTS, ...DIALOGS, ...DIRECTIVES, ...PIPES],
  entryComponents: [...DIALOGS]
})
export class UiPhoneModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<UiPhoneRootModule> {
    return {
      ngModule: UiPhoneRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
