import { Component, OnInit, Input, Output, EventEmitter } from '@angular/core';

import { FileDownloadItem } from '@ucap/domain-common';
import { FileInfo } from '@ucap/domain-chat';

@Component({
  selector: 'ucap-document-viewer',
  templateUrl: './document-viewer.component.html',
  styleUrls: ['./document-viewer.component.scss']
})
export class DocumentViewerComponent implements OnInit {
  @Input()
  fileInfo: FileInfo;

  @Input()
  fileDownloadUrl: string;

  @Output()
  download = new EventEmitter<FileDownloadItem>();

  @Output()
  closed = new EventEmitter<void>();

  fileDownloadItem: FileDownloadItem;

  constructor() {}

  ngOnInit() {}

  onClickDownload(): void {
    this.fileDownloadItem = new FileDownloadItem();
    this.download.emit(this.fileDownloadItem);
  }

  onClickClose(): void {
    this.closed.emit();
  }
}
