import { NgModule, ModuleWithProviders } from '@angular/core';

import { ModuleConfig } from '@ucap/web-storage';

import { _MODULE_CONFIG } from './config/token';

import { LocalStorageService } from './services/local-storage.service';
import { SessionStorageService } from './services/session-storage.service';

const SERVICES = [LocalStorageService, SessionStorageService];

@NgModule({})
export class WebStorageRootModule {}

@NgModule({})
export class WebStorageModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<WebStorageRootModule> {
    return {
      ngModule: WebStorageRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
